Subject: Re: [PATCH] Clarify the git-branch documentation of default start-point

From: Michael J Gruber <[email-masked]>
Date: Thu, 18 Jun 2009 09:57:09 +0200

Martin Nordholts venit, vidit, dixit 18.06.2009 08:04:
> On Wed, 2009-06-17 at 22:48 -0700, Junio C Hamano wrote:
>> Martin Nordholts <[email-masked]> writes:
>>
>>> -	is omitted, the current branch is assumed.
>>> +	is omitted, the current branch is assumed.  Note that checking
>>> +	out a remote branch does not make it the current branch.  If a
>>> +	remote branch is desired as start-point it must be an explicity
>>> +	specified.
>>
>> [...] "it" in the second new sentence is unclear.
>>
>> You probably wanted to answer "If I wanted to have _my own 'next' branch_
>> that tracks 'next' from the remote, what should I do?"
> 
> What I am trying to clarify is that a remote branch will never be the
> default for the start-point argument to git-branch, so if someone wants
> a remote branch as start-point, then the branch must be explicitly
> specified.
> 
> For this, the first sentence might actually be enough. If a remote
> branch never is the current branch, and if start-point defaults to the
> current branch, then the start-point can never default to a remote
> branch.
> 
> Should we just stick to the first sentence then perhaps?
> 

I think your usage of "start-point" is a bit unfortunate. What's a
start-point? It's the commit where a branch forks off, or more
precisely: the commit which the new branch's head is set to initially.

So, the start-point is never a branch! Or else it would be a "moving
target".

If you specify the start-point using a branch name it's really the
branch's current head which is used as the start-point.

BUT: If you specify the start-point using a branch name the DWIMery can
kick in and figure out a good default for the upstream branch (see --track).

Michael